<script setup lang="ts">
    import { getDateLocalIsoString } from '@/shared/helpers/dates'
    import { isDefined } from '@/shared/helpers/types'
    import { WritableComputedRef, computed, ref, watch } from 'vue'

    const dateDebutIntervalle = defineModel<Date | undefined>(
        'dateDebutIntervalle',
        {
            required: true,
        }
    )
    const tamponDateDebutIntervalle = ref<Date | undefined>(
        dateDebutIntervalle.value
    )
    const dateDebutIntervalleInput: WritableComputedRef<string> = computed({
        get() {
            return isDefined(tamponDateDebutIntervalle.value)
                ? getDateLocalIsoString(tamponDateDebutIntervalle.value)
                : ''
        },
        set(dateInputStr: string) {
            if (dateInputStr === '') {
                tamponDateDebutIntervalle.value = undefined
                return
            }
            // pour la date, on précise l'heure à 23:59:59.999 pour inclure toutes les heures possible de cette journée
            const dateDebutIntervalleTmp = new Date(dateInputStr)
            dateDebutIntervalleTmp.setHours(0)
            dateDebutIntervalleTmp.setMinutes(0)
            dateDebutIntervalleTmp.setSeconds(0)
            dateDebutIntervalleTmp.setMilliseconds(0)
            tamponDateDebutIntervalle.value = dateDebutIntervalleTmp
        },
    })

    const dateFinIntervalle = defineModel<Date | undefined>(
        'dateFinIntervalle',
        {
            required: true,
        }
    )
    const tamponDateFinIntervalle = ref<Date | undefined>(
        dateFinIntervalle.value
    )
    const dateFinIntervalleInput: WritableComputedRef<string> = computed({
        get() {
            return isDefined(tamponDateFinIntervalle.value)
                ? getDateLocalIsoString(tamponDateFinIntervalle.value)
                : ''
        },
        set(dateInputStr: string) {
            if (dateInputStr === '') {
                tamponDateFinIntervalle.value = undefined
                return
            }
            // pour la date, on précise l'heure à 23:59:59.999 pour inclure toutes les heures possible de cette journée
            const dateFinIntervalleTmp = new Date(dateInputStr)
            dateFinIntervalleTmp.setHours(23)
            dateFinIntervalleTmp.setMinutes(59)
            dateFinIntervalleTmp.setSeconds(59)
            dateFinIntervalleTmp.setMilliseconds(999)
            tamponDateFinIntervalle.value = dateFinIntervalleTmp
        },
    })

    // Ce watch sert à mettre à jour les valeurs des champs, notamment quand on clique sur le bouton pour supprimer les filtres
    watch([dateFinIntervalle, dateDebutIntervalle], () => {
        tamponDateFinIntervalle.value = dateFinIntervalle.value
        tamponDateDebutIntervalle.value = dateDebutIntervalle.value
    })

    function addValuesOfDatesBeingTypedInDates() {
        dateDebutIntervalle.value = tamponDateDebutIntervalle.value
        dateFinIntervalle.value = tamponDateFinIntervalle.value
    }
</script>

<template>
    <div class="d-flex flex-md-row flex-column py-2 ga-2">
        <v-text-field
            v-model="dateDebutIntervalleInput"
            type="date"
            variant="outlined"
            density="compact"
            class="date-picker"
            data-cy="input-date-debut-intervalle"
            label="Depuis"
            :hide-details="true"
        ></v-text-field>
        <v-text-field
            v-model="dateFinIntervalleInput"
            type="date"
            variant="outlined"
            density="compact"
            class="date-picker"
            data-cy="input-date-fin-intervalle"
            label="Jusqu'au"
            :hide-details="true"
        ></v-text-field>
        <v-btn
            icon="mdi-arrow-right"
            size="x-small"
            class="align-self-end align-self-md-center"
            data-cy="bouton-validation-intervalle"
            @click="addValuesOfDatesBeingTypedInDates"
        ></v-btn>
    </div>
</template>

<style scoped lang="scss">
    .date-picker :is(input) {
        cursor: text;
        display: inline-block;
        &::-webkit-calendar-picker-indicator {
            cursor: pointer;
        }
    }
</style>
